<error>
    <style>
        #error-search-item, #search-from, #search-to {
            display: flex;
        }
        #search-menu {
            margin-top: 30px;
            margin-right: 30px;
        }
        #search-from {
            margin-right: 10px;
        }
        label {
            margin-top: 5px;
            margin-right: 5px;
        }
    </style>
    <div id="error-search-item" class="hide">
        <div id="search-from">
            <label for="start">From: </label>
            <input type="text" id="start" name="start" class="form-control datetimepicker" value="{start}" />
        </div>
        <div id="search-to">
            <label for="end">To: </label>
            <input id="end" name="end" class="form-control datetimepicker" value="{ end }"/>
        </div>
    </div>
    <data/>
    <script>
        export default {
            onBeforeMount(props, state) {
                moment.locale('ja')
                this.start = moment().format('YYYY-MM-DD')
                this.end = this.start
                this.scrutiny = props.scrutiny
                this.logoutModal = props.logoutModal
            },
            onMounted(props, states) {
                clearErrorMessage()
                RiotUtil.next("data", {
                    scrutiny: this.scrutiny,
                    logoutModal: this.logoutModal,
                    title: "エラー一覧",
                    name: 'error',
                    items: ["発生時刻", "エラー種類", "リソース名","テーブル名", "処理内容", "エラーメッセージ", "削除予定日"],
                    service: new ErrorService(),
                    order: [[1, 'desc']],
                    disabledColumns: [2,3,4,5,6,7,8],
                    leftButtons: [{
                        label: '検索',
                        onclick: function (e) {
                            $("#error_datatables").dataTable().api().ajax.reload()
                        }
                    }],
                    buttons: function (dataTable, editor) {
                    },
                    ajax: async function (handler) {

                        const start = $('#start').val() ? $('#start').val() : ''
                        const end = $('#end').val() ? $('#end').val() : ''
                        const response = await this.service.search(start, end)
                        if (response.status != "OK" || !response.data || response.data.length < 1) {
                            return handler([])
                        }
                        handler(response.data)
                    },
                    initComplete: function(dt, data) {
                        $('#error-search-item').removeClass('hide')
                        $('admincontent #search-menu').prepend($('#error-search-item'))

                        $('.datetimepicker').datetimepicker({
                            dayViewHeaderFormat: 'YYYY年MM月',
                            stepping: 1,
                            locale:'ja',
                            format : 'YYYY-MM-DD'
                        });
                    },
                    addJSON: async function (json) {

                        json.columns.forEach(function (column) {
                            if (column.data == 'type') {
                                column.render = function (data, type, row) {
                                    switch (data) {
                                        case 'readTableError':
                                            return '読み込みエラー'
                                        case 'writeTableError':
                                            return '書き込みエラー'
                                    }
                                }
                            }
                            if (column.data == 'unixTime') {
                                column.render = function (data, type, row) {
                                    return moment.unix(data).format('YYYY-MM-DD')
                                }
                            }
                        })
                        return json
                    },
                }, "datatables")
            },
            search: function (e) {
                $("#error_datatables").dataTable().api().ajax.reload()
            }
        }

        function trim(data) {
            if (data == ' ') {
                return ''
            }
            return data
        }

        function clearErrorMessage() {
            $("#error-message").text('').addClass('hide')
        }
        function setErrorMessage(message) {
            $("#error-message").text(message).removeClass('hide')
        }
    </script>
</error>
